/////////////////////////////////////////////////////////////////////////////

// Name:        SampleTests.h

// Purpose:     

// Author:      Marty Saxton

// Modified by:

// Created:     10/27/2001

// RCS-ID:      $Id: wxTestSample.h,v 1.1.1.1 2001/11/10 19:00:43 thundercow Exp $

// Copyright:   (c) Marty Saxton, Thundercow Software

// Licence:     wxWindows license

/////////////////////////////////////////////////////////////////////////////



#include <wxTest/ITestRunner.h>



#include <wxTest/TestCase.h>

#include <wxTest/TestSuite.h>

#include <wxTest/TestCaller.h>



const char* FAILURE_MESSAGE = "This is a failure message.";



class SampleTests : public wxTestCase

{

public:

	// NOTE:  Implemenations provided inline for readability.



	SampleTests( const char* pszTestName ) : wxTestCase( pszTestName )	 {}



	

	// Set up this object's state before actually executing any tests.

	virtual void Setup()

	{

	}



	// Clean up anything that was allocated in Setup.

	virtual void TearDown()

	{

	}



	void Pass( wxITestRunner* , ThreadId  ) 

	{

		WXTASSERT( 2 == 2 );

	}



	void Fail( wxITestRunner* , ThreadId  ) 

	{

		WXTASSERT( 1 == 2 );

	}



	void FailWithMessage( wxITestRunner* , ThreadId )

	{

		WXTASSERTMSG( FAILURE_MESSAGE , 1==2 );

	}



	void Error( wxITestRunner*, ThreadId )

	{

		int n1 = 1;

		int n2 = 0;

		int n3 = n1 / n2;  // divide by zero should cause an error

	}



	void Output( wxITestRunner* pRunner, ThreadId )

	{

		pRunner->wxtstdout( "This is a test of %s.", "normal test output" );

	}



	static wxITest* Suite()

	{

		wxTestSuite* pSuite = new wxTestSuite("Sample");

		pSuite->AddTest ( new wxTestCaller<SampleTests> ("Pass", Pass ) );

		pSuite->AddTest ( new wxTestCaller<SampleTests> ("Fail", Fail ) );

		pSuite->AddTest ( new wxTestCaller<SampleTests> ("FailWithMessage", FailWithMessage ) );

		pSuite->AddTest ( new wxTestCaller<SampleTests> ("Output", Output ) );



		// It appears that only VC++ catches errors in catch(...).

#		ifdef __WXMSW__

			pSuite->AddTest ( new wxTestCaller<SampleTests> ("Error", Error ) );

#		endif



		return pSuite;

	}



};





