/////////////////////////////////////////////////////////////////////////////

// Name:        TestCase.cpp

// Purpose:     

// Author:      Marty Saxton

// Modified by:

// Created:     10/27/2001

// RCS-ID:      $Id: TestCase.cpp,v 1.1.1.1 2001/11/10 19:00:44 thundercow Exp $

// Copyright:   (c) Marty Saxton, Thundercow Software

// Licence:     wxWindows license

/////////////////////////////////////////////////////////////////////////////



#include <wxTest/TestCase.h>



wxTestCase::wxTestCase( const char* pszDescription, wxITest* pParent ) : 

	m_pParent( pParent ),

	m_state( unknown )

{

	const char* pEnd = pszDescription;

	while ( *pEnd )

		pEnd++;



	m_pszDescription = new char[ pEnd - pszDescription + 1 ];

	char* p = m_pszDescription;

	const char* q = pszDescription;

	while ( *q )

		*p++ = *q++;

	*p = 0;

}



wxTestCase::~wxTestCase()

{

	delete [] m_pszDescription;

}



void wxTestCase::Delete()

{

	delete this;

}



const char* wxTestCase::GetDescription()

{

	return m_pszDescription;

}



wxTestCase::TestState wxTestCase::GetState()

{

	return m_state;

}



void wxTestCase::SetState( TestState newState )

{

	m_state = newState;

}



bool wxTestCase::IsThreadSafe()

{

	return false;

}



const wxITest* wxTestCase::GetParent() const

{

	return m_pParent;

}



wxITest* wxTestCase::GetParent()

{

	return m_pParent;

}



void wxTestCase::SetParent( wxITest* pParent )

{

	m_pParent = pParent;

}



void wxTestCase::Setup()

{

}



void wxTestCase::TearDown()

{

}

