#include <wxTest/TestBase.h>



wxTestBase::wxTestBase( const char* pszDescription, wxITest* pParent ) : 

	m_pParent( pParent ),

	m_state( unknown )

{

	const char* pEnd = pszDescription;

	while ( *pEnd )

		pEnd++;



	m_pszDescription = new char[ pEnd - pszDescription + 1 ];

	char* p = m_pszDescription;

	const char* q = pszDescription;

	while ( *q )

		*p++ = *q++;

	*p = 0;

}



wxTestBase::~wxTestBase()

{

	delete [] m_pszDescription;

}



void wxTestBase::Delete()

{

	delete this;

}



const char* wxTestBase::GetDescription()

{

	return m_pszDescription;

}



wxTestBase::TestState wxTestBase::GetState()

{

	return m_state;

}



void wxTestBase::SetState( TestState newState )

{

	m_state = newState;

}



bool wxTestBase::IsThreadSafe()

{

	return false;

}



const wxITest* wxTestBase::GetParent() const

{

	return m_pParent;

}



wxITest* wxTestBase::GetParent()

{

	return m_pParent;

}



void wxTestBase::SetParent( wxITest* pParent )

{

	m_pParent = pParent;

}



void wxTestBase::Setup()

{

}



void wxTestBase::TearDown()

{

}

