#include "../include/wxTest/ITestRunner.h"

#include "../include/wxTest/TestCase.h"



wxTestCase::wxTestCase( const char* pszDescription, wxITest* pParent ) : wxTestBase( pszDescription, pParent )

{

}



//wxTestCase::~wxTestCase()

//{

//	delete [] m_pszDescription;

//}



void wxTestCase::Run( wxITestRunner* pResult, long unsigned nThreadId )

{

	try 

	{

		RunUnitTest( pResult, nThreadId );

	}

	catch ( wxTestAssertion wxtAssertion )

	{

		pResult->OnTestFailure( this, wxtAssertion.m_szMessage, wxtAssertion.m_pszFile, wxtAssertion.m_nLineNo ); 

	}

	catch(...)

	{

		pResult->OnTestFailure( this, "ERROR", "<UNKNOWN>", 0 ); 

	}

}



void wxTestCase::Run( wxITestRunner* pResult )

{

	pResult->BeginTestCase( this );

	Setup();

	pResult->SpawnThreads( this );

	TearDown();

	pResult->EndTestCase( this );

}





int wxTestCase::GetNumSubTests()

{

	return 0;

}



void wxTestCase::GetSubTests( wxITest ** pOutTests )

{

}



