/////////////////////////////////////////////////////////////////////////////

// Name:        wxTestRunnerGUIApp.h

// Purpose:     

// Author:      Marty Saxton

// Modified by:

// Created:     10/27/2001

// RCS-ID:      $Id: wxTestRunnerGUIApp.h,v 1.1.1.1 2001/11/10 19:00:46 thundercow Exp $

// Copyright:   (c) Marty Saxton, Thundercow Software

// Licence:     wxWindows license

/////////////////////////////////////////////////////////////////////////////



#include <wxTest/TestRunner.h>

#include <wx/ConfBase.h>

#include <wx/FileConf.h>

class wxTestTree;



BEGIN_DECLARE_EVENT_TYPES()

    DECLARE_EVENT_TYPE(wxEVT_TEST_OUTPUT,   wxEVT_USER_FIRST+1)

END_DECLARE_EVENT_TYPES()



class wxTestOutputEvent : public wxEvent 

{

public:

	wxTestOutputEvent() : m_pTest( NULL ) {     m_eventType = wxEVT_TEST_OUTPUT; }

	wxTestOutputEvent( wxITest* pTest ) : m_pTest( pTest ) { m_eventType = wxEVT_TEST_OUTPUT; }

	wxITest* GetTest() { return m_pTest; }



    void CopyObject(wxObject& obj) const

	{

		wxEvent::CopyObject(obj);

		wxTestOutputEvent *pOutputEvent = (wxTestOutputEvent*)&obj;

		pOutputEvent->m_pTest = m_pTest;

	}



private:

    DECLARE_DYNAMIC_CLASS(wxTestOutputEvent);



	wxITest*  m_pTest;

};





class wxTestRunnerGUIApp : public wxApp

{

public:

	wxTestRunnerGUIApp();

	virtual ~wxTestRunnerGUIApp();



    virtual bool OnInit();

	virtual void AddTest( wxITest* pTest );

	virtual void BeginTestCase( wxITest* pTest );

	virtual void EndTestCase( wxITest* pTest );

	virtual void RunTest( wxITest* pTest );

	virtual void OnTestOutput( wxITest* pTest, const char* pszOutput );

	virtual void OnTestFailure( wxITest* pTest, const char* pszMessage, const char* pszFile, unsigned long nLineNo );

	// messages from the tree control

	virtual void OnTestSelected( wxITest* );



	virtual wxString GetOutputSubDir() const;

	virtual void SetOutputSubDir( wxString strOutputDir );





	wxTestTree * m_pTestTree;

	wxTextCtrl * m_pTestResults;

	wxTextCtrl * m_pLogWindow;



	wxITest* GetTestRoot();





	void OnTestOutputEvent( wxTestOutputEvent& );



protected:

	virtual bool CompareFiles( const char* psz1, const char* psz2 );

	wxTestRunner *m_pRunner;

	//wxString m_strAppDir;

	wxFileConfig m_config;



    DECLARE_EVENT_TABLE()



};





DECLARE_APP(wxTestRunnerGUIApp)





typedef void (wxEvtHandler::*wxTestOutputFunction)(wxTestOutputEvent&);

#define EVT_TEST_OUTPUT(fn) DECLARE_EVENT_TABLE_ENTRY( wxEVT_TEST_OUTPUT, -1, -1, (wxObjectEventFunction)(wxEventFunction)(wxTestOutputFunction) & fn, (wxObject *) NULL ),

