/////////////////////////////////////////////////////////////////////////////

// Name:        wxTestTree.h

// Purpose:     

// Author:      Marty Saxton

// Modified by:

// Created:     10/27/2001

// RCS-ID:      $Id: wxTestTree.h,v 1.1.1.1 2001/11/10 19:00:46 thundercow Exp $

// Copyright:   (c) Marty Saxton, Thundercow Software

// Licence:     wxWindows license

/////////////////////////////////////////////////////////////////////////////



#ifndef __TESTTREE_H__

#define __TESTTREE_H__





#include "wx/treectrl.h"





class wxITest;

class wxTestRunnerFrame;



class wxTestRunnerTreeItemData : public wxTreeItemData

{

public:

    wxTestRunnerTreeItemData( wxITest*  pTest ) : m_pTest( pTest ) { }

	wxITest* m_pTest;

};



class wxTestTree : public wxTreeCtrl

{

public:

	wxTestTree( wxWindow* pParent, wxWindowID id  );

	void AddTestsToTree(  wxITest* pTest, const char* pszLabel, wxTreeItemId parentId = wxTreeItemId() );

	void selectTest( wxITest* pTest );

	void onTestFinished( wxITest* pTest );

	

	void UpdateTest( wxITest* pTest );





private:

    void OnLMouseDClick(wxMouseEvent& event);

	void OnSelChanged(wxTreeEvent& event);

    

	typedef std::map< wxITest*,wxTreeItemId> MapTestToTreeId;

	MapTestToTreeId m_mapTestToTreeId;



	DECLARE_EVENT_TABLE()



};



#endif //__TESTTREE_H__

