/////////////////////////////////////////////////////////////////////////////

// Name:        wxTEstRunnerText.cpp

// Purpose:     

// Author:      Marty Saxton

// Modified by:

// Created:     10/27/2001

// RCS-ID:      $Id: wxTestRunnerText.cpp,v 1.1.1.1 2001/11/10 19:00:46 thundercow Exp $

// Copyright:   (c) Marty Saxton, Thundercow Software

// Licence:     wxWindows license

/////////////////////////////////////////////////////////////////////////////





#include "wx/wxprec.h"

#ifndef WX_PRECOMP

    #include "wx/wx.h"

#endif



#include <wxTest/TestRunner.h>

#include <string.h>

#include <wx/filefn.h>

#include <wx/app.h>



#ifdef __WXMSW__

#include <windows.h>

#endif





class wxTestRunnerText : public wxTestRunner

{

	virtual void OnFoundTestModule( wxTestModule& module )

	{	

		wxTestRunner::OnFoundTestModule( module );

		printf("Loaded Test Module:  %s\n", module.m_strModuleFileName.c_str() );

	}



	virtual void BeginTestCase( wxITest* pTest )

	{

		

		printf( "Running %s\n", GetQualifiedTestDescription( pTest ).c_str() );

		wxTestRunner::BeginTestCase( pTest );

	}





	void OnTestFailure( wxITest* pTest, const char* pszMessage, const char* pszFile, unsigned long nLineNo )

	{

		wxTestRunner::OnTestFailure( pTest, pszMessage, pszFile, nLineNo );



		printf("fail: '%s': ", pTest->GetDescription() );

		if ( pszMessage && *pszMessage ) 

			printf("%s;  %s:%d\n", pszMessage, pszFile, nLineNo );

		else

			printf("%s:%d\n", pszFile, nLineNo );

	}

};



class wxTextTestRunnerApp : public wxApp

{

public:



	~wxTextTestRunnerApp() {}

    virtual bool OnInit()

	{

		wxTestRunnerText testRunner;



		printf("Loading tests...\n");

		testRunner.LoadTests();

		printf("\nRunning tests...\n");

		testRunner.BeginTests();



		printf(	"\nTests Complete.\n"

				"Tests run:  %d\n"

				"Failures:   %d\n",  testRunner.GetNumTestsRun(), testRunner.GetNumFailures() );

		return false;

	}



};



IMPLEMENT_APP( wxTextTestRunnerApp )



#ifdef __WXMSW__

int main()

{

	wxEntry( GetModuleHandle(NULL), NULL, "", 1 , 1);

	return 0;

}

#endif

